#include <LiquidCrystal_I2C.h>
    LiquidCrystal_I2C lcd(0x3f,16,2);  // Устанавливаем дисплей

  #define Port_sw       11            // порт кнопки переключения диапазона мощьности
  #define Port_rele     16            // контакт на плате управления ключами делителя  
  #define Port_aktiv    true         // значение в порту для включения делителей
  #define Port_0        A1          // порт чтения показаний прямой волны
  #define Port_1        A0           // порт чтения показаний обратной волны
  #define KV            20.47        // коэфициент преобразования вольт из порта в реальные вольты
  #define ShowFreeze    1700;        // сколько тактов не будет менятся изображение
  #define Resistance    50.0         // сопротивление нагрузки в омах
  #define LPower        100          // предел для минимального диапазона мощьности
  #define HPower        1000         // максимально допустима мощьность 
  #define Minpowerswr   10.0         // минимальная мощьность для подщёта swr
  #define LcdStrLen     16           // символов в строке дисплея
  #define PwrSeparator  99.9          // после какой мощьности использовать целочисленный вывод  
  #define Logo_show     false          // отображать заставку при включении
//--------------------------------------------------------
  



struct st_port
{
word A0;
word A1;  
} Port;



//-------------------------


  float    V0=0.0;               // значение в порту в вольтах
  float    V1=0.0;               // значение в порту в вольтах
  word     ShowCount=ShowFreeze; // щётчик задержки отрисовки 


//=================================================================


void setup()
{
  Serial.begin(9600);     // инициируем СОМ порт
  
 
  pinMode(Port_0, INPUT);
  pinMode(Port_1, INPUT); 
  pinMode(Port_sw, INPUT);
  pinMode(Port_rele, OUTPUT);
  
  lcd.init(); lcd.clear();  
  lcd.backlight();// Включаем подсветку дисплея  
  



if(Logo_show==true)
  {
    lcd.setCursor(0, 0);  lcd.print(" PWR SWR METER");
    char st[4];
    char s[LcdStrLen+1]={"MAX POWER     WT"};s[LcdStrLen]=0;
    dtostrf(float(HPower), 4, 0,st );
    strncpy( s+10,st, 4);
    for (word n=0; n<4; n++)       //  моргаем предупреждением
       {
         lcd.setCursor(0, 1);lcd.print(s);  delay(1000);
         lcd.setCursor(0, 1);lcd.print("                ");  delay(700);
       }
   }
  
  lcd.clear();
}

//===========================================================


void ShowLCDDebug() 
{
   lcd.clear();
   lcd.setCursor(0, 0); lcd.print("A0="); lcd.print(Port.A0);lcd.print(" V0=");lcd.print(V0);
   lcd.setCursor(0, 1); lcd.print("A1="); lcd.print(Port.A1);lcd.print(" V1=");lcd.print(V1);
}


//==================================================================================



//====================================


//=================================================================================

void portread1()                               // средне арифметическое
{
  long int UT0=0;  long int UT1=0;
  byte n=0;
  for ( n=0;n<5;n++)
    {
        UT0 = UT0 + analogRead(Port_0);           
        UT1 = UT1 + analogRead(Port_1);          
    }
  Port.A0=UT0 / n;
  Port.A1=UT1 / n;
  }
//==================================================================================

void portread2()                                 // максимальное в пике
{
    word UT0 =  analogRead(Port_0);       
    word UT1 =  analogRead(Port_1);      
    
  //  if (UT0 > Port.A0)
    {Port.A0=UT0;Port.A1=UT1;}   
}
//====================================================================




void loop()
{
 if (digitalRead(Port_sw)==Port_aktiv)
      digitalWrite(Port_rele,true);
    else  
      digitalWrite(Port_rele,false);


 
  portread2();
  Calc();


if ((ShowCount < 1))
  {
     ShowCount=ShowFreeze;
     ShowLCDDebug();
     Port.A0=0;Port.A1=0;
  }

ShowCount=ShowCount-1;

}


//===================================================================================

void Calc() 
{

  //float V0=(U1*5.0)/1023.0;  // включить в релизе
  //float V1=(U2*5.0)/1023.0;   // включить в релизе

   V0=(Port.A0*5.0)/1023.0;
   V1=(Port.A1*5.0)/1023.0; 


   V0=V0*KV;
   V1=V1*KV;

 

}








  
