/***************************************************************************************************/
#include <Wire.h>
#include <MCP4725.h>





//=======================================================================

#define MaxValue      200  //   максимальное значение на показометре (у меня 200 mka)

//=========================================================================



#define DAC_REF_VOLTAGE 5.140  //dac supply-reference voltage
#define I2C_BUS_SPEED   100000 //i2c bus speed, 100 000Hz or 400 000Hz


MCP4725 dac(MCP4725A0_ADDR_A00, DAC_REF_VOLTAGE);

/**************************************************************************/
/*
    setup()

    Main setup
*/
/**************************************************************************/
void setup()
{
  Serial.begin(9600);
  Serial.println();

  while (dac.begin() != true)
  {
    Serial.println(F("MCP4725 is not connected")); //(F()) saves string to flash & keeps dynamic memory free
    delay(5000);
  }

  Serial.println(F("MCP4725 is OK"));

  Wire.setClock(I2C_BUS_SPEED);                    //experimental! i2c bus speed 100kHz..400kHz/100000..400000, default 100000
}


/**************************************************************************/
/*
    loop()

    Main loop
*/
/**************************************************************************/
void loop()
{

int in=0; 

 for (in=0;in<=MaxValue;in=in+25)
 {
int value= map(in, 0, MaxValue, 0, 4095);
  Serial.println(value);
  dac.setValue(value, MCP4725_FAST_MODE, MCP4725_POWER_DOWN_OFF);
  delay(2000);
 }
delay(5000);
}
  
  
