
#include <Wire.h>
#include <MCP4725.h>

   
  #define StrelkaSwrMax 3                      //максимальное значение ксв на показометре
  #define StrelkaSwrMin 1                      //минимальное значение ксв на показометре
  #define StrelkaPwrMax 120                    //максимальное значение мощьности на показометре
  #define StrelkaPwrMin 0                      //минимальное значение мощьности на показометре

  #define Port_sw_swr            11            // порт кнопки смена режимов PWR / SWR
  #define Port_sw_pwr            12            // порт кнопки переключения диапазона мощьности 100 / 1000
  #define Port_rele              16            // контакт на плате управления ключами делителя  
  #define Port_aktiv           true            // значение в порту для включения делителей (true или false)

  #define Port_0                 A1            // порт чтения показаний прямой волны при необходимости поменять местами
  #define Port_1                 A0            // порт чтения показаний обратной волны при необходимости поменять местами

  #define ShowFreeze            800             // сколько тактов не будет двигаться стрелка
  #define OtkatFreeze            30               // замедлитель отката стрелки (чем больше тем медленние)
  #define NakatFreeze             2                // замедлитель наката стрелки (чем больше тем быстрее)
  #define KV                  20.47           // коэфициент преобразования вольт из порта в реальные вольты

//--------------------------------------------------------

 
  #define Resistance           50.0            // сопротивление нагрузки в омах
  #define I2C_BUS_SPEED      100000            //скорость порта i2c
  #define  DacMax             4095             // максимальное значение для цап
  #define  DacMin                0             // минимальное значение для цап
  #define DAC_REF_VOLTAGE    5.140             //опорное напряжение цап (= равно питанию цап)
   
   
   
     struct st_port {word A0;word A1;} Port;

//-------------------------


  float    ShowPWR=0.0;            //  отображаемое значение  мощьности
  float    ShowSWR=0.0;            //  отображаемое значение КСВ
  float    PWR=0.0;                // текущее  значение  мощьности
  float    SWR=0.0;                // текущее значение КСВ
  float    V0=0.0;                 // значение в порту в вольтах
  float    V1=0.0;                 // значение в порту в вольтах
  word     ShowCount=ShowFreeze;   // щётчик задержки отрисовки 
  word     OtkatCount=OtkatFreeze; // щётчик задержки отрисовки


  MCP4725 dac(MCP4725A0_ADDR_A00, DAC_REF_VOLTAGE);
 
//=================================================================


void setup()
{
// Serial.begin(9600);
  Wire.setClock(I2C_BUS_SPEED);                      


  while (dac.begin() != true)  delay(2000); 
 
  pinMode(Port_0, INPUT);
  pinMode(Port_1, INPUT); 
  pinMode(Port_sw_pwr, INPUT);
  pinMode(Port_sw_swr, INPUT);
  pinMode(Port_rele, OUTPUT);
 
}


//==================================================================================


void ShowStrelkaPWR()
 {
    //  Serial.println(ShowPWR);
    int  value= map(ShowPWR, StrelkaPwrMin, StrelkaPwrMax, DacMin, DacMax);
    dac.setValue(value, MCP4725_FAST_MODE, MCP4725_POWER_DOWN_OFF);
   
 }

//=================================================================================


void ShowStrelkaSWR()
 {
  // Serial.println(ShowSWR*100); 
   int  value=map(ShowSWR*100, StrelkaSwrMin*100, StrelkaSwrMax*100, DacMin, DacMax); 
   dac.setValue(value, MCP4725_FAST_MODE, MCP4725_POWER_DOWN_OFF);
 // умноженое на 100 нужно чтоб в функции map не игнорировалась дробная часть числа
    
    
    
 }



//=================================================================================

void portread1()                               // средне арифметическое
{
  long int UT0=0;  long int UT1=0;
  byte n=0;
  
  analogRead(Port_0);analogRead(Port_1); //чтение для стабилизации портов
  
  for ( n=0;n<5;n++)
    {
        UT0 = UT0 + analogRead(Port_0);           
        UT1 = UT1 + analogRead(Port_1);          
    }
  Port.A0=UT0 / n;
  Port.A1=UT1 / n;
  }
//==================================================================================

void portread2()                                 // максимальное в пике
{
    analogRead(Port_0);analogRead(Port_1); //чтение для стабилизации портов
    
    word UT0 =  analogRead(Port_0);       
    word UT1 =  analogRead(Port_1);      
    
    if (UT0 > Port.A0) {Port.A0=UT0;Port.A1=UT1;}   
}
//====================================================================




void loop()
{
 if (digitalRead(Port_sw_pwr)==Port_aktiv)
    digitalWrite(Port_rele,true);
  else  
    digitalWrite(Port_rele,false);

  
     if (digitalRead(Port_sw_swr)==Port_aktiv)
      {                                       //начало отображение ксв
         portread1();  // средне арифметическое
         Calc();
         ShowSWR=SWR;
         ShowStrelkaSWR();
         Port.A0=0;Port.A1=0;
      }                                       //конец отображение ксв
    else
      {                                       //начало отображение мощьности
        portread1();
        Calc();       
        if (PWR > ShowPWR)                //  двигаем стрелку в верх если новое значение больше текущего  
            {                                   
              ShowCount=ShowFreeze;
              OtkatCount=OtkatFreeze;
              ShowPWR=ShowPWR+NakatFreeze;  // плавное увеличение показаний
              ShowStrelkaPWR();
              Port.A0=0;Port.A1=0;
            }
        if (ShowCount > 1)                   
             ShowCount=ShowCount-1;         //задержка перед откатом
           else
              {                             //начало реализация отката
                 if (OtkatCount > 1)
                      OtkatCount=OtkatCount-1;
                   else 
                      { OtkatCount=OtkatFreeze; if (ShowPWR>0.9) ShowPWR=ShowPWR-1;  ShowStrelkaPWR();    }
              }                              //конец реализация отката
        
      }                                              //конец отображение мощьности
}



//===================================================================================

void Calc() 
{

   V0=((Port.A0*5.0)/1023.0)*KV;
   V1=((Port.A1*5.0)/1023.0)*KV; 
   PWR=(V0*V0)/Resistance; 
   if ((V0 - V1)<=0) 
      SWR=1.0; 
    else
      SWR=float (float(V0+V1) / float(V0-V1)); // вычисляем отношение КСВ  через вольты
}



//==============================================








  
